CS61B Guide
  • This site is now deprecated
  • Object Oriented Programming
    • Inheritance
    • Access Control
    • Dynamic Method Selection
    • Java Objects
    • Generic Types
  • Asymptotics
    • Asymptotic Analysis Basics
    • Amortization
    • Asymptotics Practice
  • Abstract Data Types
    • Collections
      • Arrays
      • Linked Lists
      • Sets
      • Stacks and Queues
    • Binary Trees
      • Heaps
      • Balanced BSTs
      • Tries
    • Graphs
    • Hashing and Hash Tables
    • Union Find (Disjoint Sets)
    • Comparables and Comparators
  • Sorting
    • Sorting
  • Algorithms
    • Minimax Algorithm
    • Searching
      • Binary Search
      • Depth First Search (DFS)
      • Breadth First Search (BFS)
    • Shortest Paths
      • Dijkstra's Algorithm
      • A* Search
    • Minimum Spanning Trees
      • Prim's Algorithm
      • Kruskal's Algorithm
  • Misc Topics
    • Modular Arithmetic and Bit Manipulation
    • Exceptions
    • More Resources
Powered by GitBook
On this page
  • Introduction
  • Loops
  • Recursion
  • Best and Worst Case Runtimes
  • Challenge Problems

Was this helpful?

  1. Asymptotics

Asymptotics Practice

PreviousAmortizationNextCollections

Last updated 5 years ago

Was this helpful?

Make sure to review before proceeding with these problems.

Introduction

Asymptotics is a very intuition-based concept that often doesn't have a set algorithm for computing. The best way to get good at analyzing programs is to practice!

With that said, here are some problems of increasing difficulty for you to enjoy 😊

For all of the below problems, assume that all undefined functions have a constant O(1) complexity.

Loops

What runtime does this function have?

void throwHalfOfMyItems(int n) {
    for (int i = 0; i < n; i += 1) {
        if (i % 2 == 0)
            throwItem(n);
    }
}
Θ(n)\Theta(n)Θ(n)

Explanation: The method throwItem() runs n/2 times. Using the simplification rules, we can extract the constant 1/2 to simply get n.

What runtime does this function have?

void lootShulkerBoxes(int n) {
    for (int box = n; box > 0; box -= 1) {
        for (int stack = 0; stack < n; stack += 1) {
            for (int i = 0; i < 64; i += 1) {
                lootItem(i * stack * box);
            }
        }
    }       
}
Θ(n2)\Theta(n^2)Θ(n2)

Explanation: There are three nested loops in this problem. Whenever there are nested loops whose runtimes are independent of each other, we need to multiply the runtimes in each loop. So, we get: Θ(n∗n∗64)\Theta(n * n * 64)Θ(n∗n∗64) which simplifies into n^2

I've tweaked the previous problem a little 😁 Try to spot the difference and see if it changes the runtime at all!

void lootShulkerBoxes(int n, int stacksToLoot) {
    for (int box = n; box > 0; box -= 1) {
        for (int stack = stacksToLoot; stack > 0; stack -= 1) {
            for (int i = 0; i < 64; i += 1) {
                lootItem(i * stack * box);
            }
        }
    }       
}

Recursion

TREEEEEEEEE recursion 🌳🌲🌴

void plantJungleSaplings(int n) {
    if (n > 0) {
        for (int i = 0; i < 4; i += 1) {
            plantJungleSaplings(n - 1);
        }
    }
}

Explanation: This tree recursion creates a tree with n layers. Each layer you go down, the number of calls multiplies by 4!

This means that the number of calls in total will look like this:

Let's replace the 4 in the previous problem with n and see what insanity ensues.

void plantCrazySaplings(int n) {
    if (n > 0) {
        for (int i = 0; i < n; i += 1) { // This line changed
            plantCrazySaplings(n - 1);
        }
    }
}

Explanation: This tree recursion creates a tree with n layers. Each layer you go down, the number of calls multiplies by n-1...

This means that the number of calls in total will look like this:

Since n! is not dependent on i it can be factored out of the sum to produce this:

Best and Worst Case Runtimes

Here's a case where the best case and worst case runtimes are different. Can you figure out what they are? (Let n = items.length).

Item[] hopperSort(Item[] items) {
    int n = arr.length; 
    for (int i = 1; i < n; ++i) { 
        int key = items[i]; 
        int j = i - 1; 
        while (j >= 0 && items[j].compareTo(key) > 0) { 
            items[j + 1] = items[j]; 
            j = j - 1; 
        } 
        items[j + 1] = key; 
    } 
}

Note: HopperSort is literally just Insertion Sort 😎🤣

Here's a mutual recursion problem! What are the best and worst cases for explodeTNT(n)? What are their runtimes?

void explodeTNT(int n) {
    if (n % 2 == 0) {
        digDirts(n - 1, true);
        digDirts(n - 2, false);
    } else {
        digDirts(n / 2, true);
    }
}

void digDirts(int n, boolean isTNT) {
    if (isTNT) {
        explodeTNT(n / 2);
    }
    removeDirt(); // not implemented, assume O(1) runtime
}

Challenge Problems

These problems are quite difficult. Don't be concerned if you don't feel confident in solving them (I certainly don't).

A huge disaster :ooo

//initially start is 0, end is arr.length.
public int PNH(char[] arr, int start, int end) {
    if (end <= start) {
        return 1;
    }
    int counter = 0; 
    int result = 0;
    for (int i = start; i < end; i += 1) {
        if (arr[i] == 'a') {
            counter += 1;
        }
    }
    for (int i = 0; i < counter; i += 1) {
        result += PNH(arr, start + 1, end);
    }
    int mid = start + (end - start) / 2;
    return PNH(arr, start, mid) + PNH(arr, mid + 1, end);
}

Congrats for making it this far! By now you should be an expert in asymptotic analysis :P Here's one last problem:

//initially start is 0, end is arr.length.
public int lastOne(char[] arr, int start, int end) {
    if (end <= start) {
        return 1;
    }
    else if (arr[start] <= arr[end]) {
        return lastOne(arr, start + 1, end - 1);
    } else {
        int temp = arr[start];
        arr[start] = arr[end];
        arr[end] = temp;

        return lastOne(arr, start + 1, end) 
        + lastOne(arr, start, end - 1) 
        + lastOne(arr, start + 1, end - 1);
    }
}
Θ(n)\Theta(n)Θ(n)

Explanation: Even though stacksToLoot is a user input, we're only concerned about finding the runtime for n so stacksToLoot can be treated like a constant! Therefore, we now have Θ(n∗s∗64)\Theta(n * s* 64)Θ(n∗s∗64) where s = stacksToLoot which simplifies into n.

The following two problems are inspired by .

Θ(4n)\Theta(4^n)Θ(4n)
∑i=1n4i\sum_{i=1}^{n}4^ii=1∑n​4i

And if you remember your power series, you'll know that this sum is equal to 4n+1−14^{n+1}-14n+1−1 which simplifies into the final answer.

Θ(n!)\Theta(n!)Θ(n!)
∑i=1nn!i!\sum_{i=1}^{n} \frac{n!}{i!}i=1∑n​i!n!​
n!∑i=1n1i!n!\sum_{i=1}^{n} \frac{1}{i!}n!i=1∑n​i!1​

Hey, that looks a lot like the Taylor series for eee! Since e is a constant, it simply reduces to n!.

Best Case: Θ(n)\Theta(n)Θ(n) if the array is nearly sorted except for a couple values. In this case, the while loop will only run a small number of times, so the only loop left is the for loop.

Worst Case: Θ(n2)\Theta(n^2)Θ(n2)if the array is totally reversed. This will cause the while loop to run on the order of O(n) times, resulting in a nested loop.

Best Case: Θ(log⁡(n))\Theta(\log(n))Θ(log(n)) if n is even. This will result in n being halved every function call.

Worst Case: Θ(n)\Theta(n)Θ(n)if n is odd. See the tree below for an illustration of what happens in this case- hopefully the diagram will make it clearer as to why it's O(n).

Best Case: Θ(nlog⁡(n))\Theta(n\log(n))Θ(nlog(n)) If none of the characters in char[] is 'a', then each call to PNH does Θ(n)\Theta(n)Θ(n) work. Total work per layer is always N, with logN layers total.

Worst Case: Θ(n!)\Theta(n!)Θ(n!) All of characters in char[] is 'a'. In this case, the for loop recursive calls will dominate the runtime, because it'll be the main part of the recursive tree. The interval start to end is decreased by one in the for loop recursive calls, while that interval is halved in the return statement recursive calls. This means the return statement recursive calls will reach the base case in logn levels, while the recursive calls in the for loop will take n levels. Thus, we can proceed with the same analysis as question 4.

Best Case: Θ(n)\Theta(n)Θ(n) if the else if case is always true. This will produce a tree with height n/2, where each height does constant work.

Worst Case: Θ(3n)\Theta(3^n)Θ(3n) if else if case is never true. Sorry no diagram yet :((

this worksheet
Asymptotic Analysis Basics
Keep the change, ya filthy animal.
That's a lot of items to loot...
ok now this is getting a bit overboard
Tree diagram for method calls.
an image that makes you long for TreeCapacitator
What a mess (!)
hoppers rate 64/64
A diagram of what happens in the worst and best cases.
don't play with tnt, kids